# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'ClusterFile',
    'ClusterHook',
    'ClusterHooks',
    'ClusterHost',
    'ClusterK0s',
    'ClusterLocalhost',
    'ClusterMetadata',
    'ClusterSSH',
    'ClusterSpec',
    'ClusterWinRM',
    'K0s',
    'K0sAPI',
    'K0sCalico',
    'K0sCalicoImage',
    'K0sControllerManager',
    'K0sDualStack',
    'K0sEnvoyProxy',
    'K0sEtcd',
    'K0sEtcdExternalCluster',
    'K0sFeatureGate',
    'K0sImage',
    'K0sImages',
    'K0sInstallConfig',
    'K0sInstallConfigUser',
    'K0sKine',
    'K0sKonnectivity',
    'K0sKubeProxy',
    'K0sKubeProxyIPTables',
    'K0sKubeProxyIPVS',
    'K0sKubeRouter',
    'K0sKubeRouterImage',
    'K0sMetadata',
    'K0sNetwork',
    'K0sNodeLocalLoadBalancing',
    'K0sPodSecurityPolicy',
    'K0sScheduler',
    'K0sSpec',
    'K0sStorage',
    'K0sTelemetry',
    'K0sWorkerProfile',
]

@pulumi.output_type
class ClusterFile(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dirPerm":
            suggest = "dir_perm"
        elif key == "dstDir":
            suggest = "dst_dir"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterFile. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterFile.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterFile.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dir_perm: Optional[str] = None,
                 dst: Optional[str] = None,
                 dst_dir: Optional[str] = None,
                 group: Optional[str] = None,
                 name: Optional[str] = None,
                 perm: Optional[str] = None,
                 src: Optional[str] = None,
                 user: Optional[str] = None):
        if dir_perm is not None:
            pulumi.set(__self__, "dir_perm", dir_perm)
        if dst is not None:
            pulumi.set(__self__, "dst", dst)
        if dst_dir is not None:
            pulumi.set(__self__, "dst_dir", dst_dir)
        if group is not None:
            pulumi.set(__self__, "group", group)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if perm is not None:
            pulumi.set(__self__, "perm", perm)
        if src is not None:
            pulumi.set(__self__, "src", src)
        if user is not None:
            pulumi.set(__self__, "user", user)

    @property
    @pulumi.getter(name="dirPerm")
    def dir_perm(self) -> Optional[str]:
        return pulumi.get(self, "dir_perm")

    @property
    @pulumi.getter
    def dst(self) -> Optional[str]:
        return pulumi.get(self, "dst")

    @property
    @pulumi.getter(name="dstDir")
    def dst_dir(self) -> Optional[str]:
        return pulumi.get(self, "dst_dir")

    @property
    @pulumi.getter
    def group(self) -> Optional[str]:
        return pulumi.get(self, "group")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def perm(self) -> Optional[str]:
        return pulumi.get(self, "perm")

    @property
    @pulumi.getter
    def src(self) -> Optional[str]:
        return pulumi.get(self, "src")

    @property
    @pulumi.getter
    def user(self) -> Optional[str]:
        return pulumi.get(self, "user")


@pulumi.output_type
class ClusterHook(dict):
    def __init__(__self__, *,
                 after: Optional[Sequence[str]] = None,
                 before: Optional[Sequence[str]] = None):
        if after is not None:
            pulumi.set(__self__, "after", after)
        if before is not None:
            pulumi.set(__self__, "before", before)

    @property
    @pulumi.getter
    def after(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "after")

    @property
    @pulumi.getter
    def before(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "before")


@pulumi.output_type
class ClusterHooks(dict):
    def __init__(__self__, *,
                 apply: Optional['outputs.ClusterHook'] = None,
                 backup: Optional['outputs.ClusterHook'] = None,
                 reset: Optional['outputs.ClusterHook'] = None):
        if apply is not None:
            pulumi.set(__self__, "apply", apply)
        if backup is not None:
            pulumi.set(__self__, "backup", backup)
        if reset is not None:
            pulumi.set(__self__, "reset", reset)

    @property
    @pulumi.getter
    def apply(self) -> Optional['outputs.ClusterHook']:
        return pulumi.get(self, "apply")

    @property
    @pulumi.getter
    def backup(self) -> Optional['outputs.ClusterHook']:
        return pulumi.get(self, "backup")

    @property
    @pulumi.getter
    def reset(self) -> Optional['outputs.ClusterHook']:
        return pulumi.get(self, "reset")


@pulumi.output_type
class ClusterHost(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "installFlags":
            suggest = "install_flags"
        elif key == "k0sBinaryPath":
            suggest = "k0s_binary_path"
        elif key == "noTaints":
            suggest = "no_taints"
        elif key == "privateAddress":
            suggest = "private_address"
        elif key == "privateInterface":
            suggest = "private_interface"
        elif key == "uploadBinary":
            suggest = "upload_binary"
        elif key == "winRM":
            suggest = "win_rm"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterHost. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterHost.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterHost.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 role: str,
                 environment: Optional[Mapping[str, str]] = None,
                 files: Optional[Sequence['outputs.ClusterFile']] = None,
                 hooks: Optional['outputs.ClusterHooks'] = None,
                 hostname: Optional[str] = None,
                 install_flags: Optional[Sequence[str]] = None,
                 k0s_binary_path: Optional[str] = None,
                 localhost: Optional['outputs.ClusterLocalhost'] = None,
                 no_taints: Optional[bool] = None,
                 os: Optional[str] = None,
                 private_address: Optional[str] = None,
                 private_interface: Optional[str] = None,
                 ssh: Optional['outputs.ClusterSSH'] = None,
                 upload_binary: Optional[bool] = None,
                 win_rm: Optional['outputs.ClusterWinRM'] = None):
        pulumi.set(__self__, "role", role)
        if environment is not None:
            pulumi.set(__self__, "environment", environment)
        if files is not None:
            pulumi.set(__self__, "files", files)
        if hooks is not None:
            pulumi.set(__self__, "hooks", hooks)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if install_flags is not None:
            pulumi.set(__self__, "install_flags", install_flags)
        if k0s_binary_path is not None:
            pulumi.set(__self__, "k0s_binary_path", k0s_binary_path)
        if localhost is not None:
            pulumi.set(__self__, "localhost", localhost)
        if no_taints is not None:
            pulumi.set(__self__, "no_taints", no_taints)
        if os is not None:
            pulumi.set(__self__, "os", os)
        if private_address is not None:
            pulumi.set(__self__, "private_address", private_address)
        if private_interface is not None:
            pulumi.set(__self__, "private_interface", private_interface)
        if ssh is not None:
            pulumi.set(__self__, "ssh", ssh)
        if upload_binary is not None:
            pulumi.set(__self__, "upload_binary", upload_binary)
        if win_rm is not None:
            pulumi.set(__self__, "win_rm", win_rm)

    @property
    @pulumi.getter
    def role(self) -> str:
        return pulumi.get(self, "role")

    @property
    @pulumi.getter
    def environment(self) -> Optional[Mapping[str, str]]:
        return pulumi.get(self, "environment")

    @property
    @pulumi.getter
    def files(self) -> Optional[Sequence['outputs.ClusterFile']]:
        return pulumi.get(self, "files")

    @property
    @pulumi.getter
    def hooks(self) -> Optional['outputs.ClusterHooks']:
        return pulumi.get(self, "hooks")

    @property
    @pulumi.getter
    def hostname(self) -> Optional[str]:
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter(name="installFlags")
    def install_flags(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "install_flags")

    @property
    @pulumi.getter(name="k0sBinaryPath")
    def k0s_binary_path(self) -> Optional[str]:
        return pulumi.get(self, "k0s_binary_path")

    @property
    @pulumi.getter
    def localhost(self) -> Optional['outputs.ClusterLocalhost']:
        return pulumi.get(self, "localhost")

    @property
    @pulumi.getter(name="noTaints")
    def no_taints(self) -> Optional[bool]:
        return pulumi.get(self, "no_taints")

    @property
    @pulumi.getter
    def os(self) -> Optional[str]:
        return pulumi.get(self, "os")

    @property
    @pulumi.getter(name="privateAddress")
    def private_address(self) -> Optional[str]:
        return pulumi.get(self, "private_address")

    @property
    @pulumi.getter(name="privateInterface")
    def private_interface(self) -> Optional[str]:
        return pulumi.get(self, "private_interface")

    @property
    @pulumi.getter
    def ssh(self) -> Optional['outputs.ClusterSSH']:
        return pulumi.get(self, "ssh")

    @property
    @pulumi.getter(name="uploadBinary")
    def upload_binary(self) -> Optional[bool]:
        return pulumi.get(self, "upload_binary")

    @property
    @pulumi.getter(name="winRM")
    def win_rm(self) -> Optional['outputs.ClusterWinRM']:
        return pulumi.get(self, "win_rm")


@pulumi.output_type
class ClusterK0s(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dynamicConfig":
            suggest = "dynamic_config"
        elif key == "versionChannel":
            suggest = "version_channel"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterK0s. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterK0s.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterK0s.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 config: Optional['outputs.K0s'] = None,
                 dynamic_config: Optional[bool] = None,
                 version: Optional[str] = None,
                 version_channel: Optional[str] = None):
        if config is not None:
            pulumi.set(__self__, "config", config)
        if dynamic_config is not None:
            pulumi.set(__self__, "dynamic_config", dynamic_config)
        if version is not None:
            pulumi.set(__self__, "version", version)
        if version_channel is not None:
            pulumi.set(__self__, "version_channel", version_channel)

    @property
    @pulumi.getter
    def config(self) -> Optional['outputs.K0s']:
        return pulumi.get(self, "config")

    @property
    @pulumi.getter(name="dynamicConfig")
    def dynamic_config(self) -> Optional[bool]:
        return pulumi.get(self, "dynamic_config")

    @property
    @pulumi.getter
    def version(self) -> Optional[str]:
        return pulumi.get(self, "version")

    @property
    @pulumi.getter(name="versionChannel")
    def version_channel(self) -> Optional[str]:
        return pulumi.get(self, "version_channel")


@pulumi.output_type
class ClusterLocalhost(dict):
    def __init__(__self__, *,
                 enabled: Optional[bool] = None):
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        return pulumi.get(self, "enabled")


@pulumi.output_type
class ClusterMetadata(dict):
    def __init__(__self__, *,
                 name: str):
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


@pulumi.output_type
class ClusterSSH(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "hostKey":
            suggest = "host_key"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterSSH. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterSSH.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterSSH.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 address: str,
                 bastion: Optional['outputs.ClusterSSH'] = None,
                 host_key: Optional[str] = None,
                 key: Optional[str] = None,
                 port: Optional[int] = None,
                 user: Optional[str] = None):
        pulumi.set(__self__, "address", address)
        if bastion is not None:
            pulumi.set(__self__, "bastion", bastion)
        if host_key is not None:
            pulumi.set(__self__, "host_key", host_key)
        if key is not None:
            pulumi.set(__self__, "key", key)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if user is not None:
            pulumi.set(__self__, "user", user)

    @property
    @pulumi.getter
    def address(self) -> str:
        return pulumi.get(self, "address")

    @property
    @pulumi.getter
    def bastion(self) -> Optional['outputs.ClusterSSH']:
        return pulumi.get(self, "bastion")

    @property
    @pulumi.getter(name="hostKey")
    def host_key(self) -> Optional[str]:
        return pulumi.get(self, "host_key")

    @property
    @pulumi.getter
    def key(self) -> Optional[str]:
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def port(self) -> Optional[int]:
        return pulumi.get(self, "port")

    @property
    @pulumi.getter
    def user(self) -> Optional[str]:
        return pulumi.get(self, "user")


@pulumi.output_type
class ClusterSpec(dict):
    def __init__(__self__, *,
                 hosts: Sequence['outputs.ClusterHost'],
                 k0s: Optional['outputs.ClusterK0s'] = None):
        pulumi.set(__self__, "hosts", hosts)
        if k0s is not None:
            pulumi.set(__self__, "k0s", k0s)

    @property
    @pulumi.getter
    def hosts(self) -> Sequence['outputs.ClusterHost']:
        return pulumi.get(self, "hosts")

    @property
    @pulumi.getter
    def k0s(self) -> Optional['outputs.ClusterK0s']:
        return pulumi.get(self, "k0s")


@pulumi.output_type
class ClusterWinRM(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "caCert":
            suggest = "ca_cert"
        elif key == "tlsServerName":
            suggest = "tls_server_name"
        elif key == "useHTTPS":
            suggest = "use_https"
        elif key == "useNTLM":
            suggest = "use_ntlm"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterWinRM. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterWinRM.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterWinRM.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 address: str,
                 bastion: Optional['outputs.ClusterSSH'] = None,
                 ca_cert: Optional[str] = None,
                 cert: Optional[str] = None,
                 insecure: Optional[bool] = None,
                 key: Optional[str] = None,
                 password: Optional[str] = None,
                 port: Optional[int] = None,
                 tls_server_name: Optional[str] = None,
                 use_https: Optional[bool] = None,
                 use_ntlm: Optional[bool] = None,
                 user: Optional[str] = None):
        pulumi.set(__self__, "address", address)
        if bastion is not None:
            pulumi.set(__self__, "bastion", bastion)
        if ca_cert is not None:
            pulumi.set(__self__, "ca_cert", ca_cert)
        if cert is not None:
            pulumi.set(__self__, "cert", cert)
        if insecure is not None:
            pulumi.set(__self__, "insecure", insecure)
        if key is not None:
            pulumi.set(__self__, "key", key)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if tls_server_name is not None:
            pulumi.set(__self__, "tls_server_name", tls_server_name)
        if use_https is not None:
            pulumi.set(__self__, "use_https", use_https)
        if use_ntlm is not None:
            pulumi.set(__self__, "use_ntlm", use_ntlm)
        if user is not None:
            pulumi.set(__self__, "user", user)

    @property
    @pulumi.getter
    def address(self) -> str:
        return pulumi.get(self, "address")

    @property
    @pulumi.getter
    def bastion(self) -> Optional['outputs.ClusterSSH']:
        return pulumi.get(self, "bastion")

    @property
    @pulumi.getter(name="caCert")
    def ca_cert(self) -> Optional[str]:
        return pulumi.get(self, "ca_cert")

    @property
    @pulumi.getter
    def cert(self) -> Optional[str]:
        return pulumi.get(self, "cert")

    @property
    @pulumi.getter
    def insecure(self) -> Optional[bool]:
        return pulumi.get(self, "insecure")

    @property
    @pulumi.getter
    def key(self) -> Optional[str]:
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def password(self) -> Optional[str]:
        return pulumi.get(self, "password")

    @property
    @pulumi.getter
    def port(self) -> Optional[int]:
        return pulumi.get(self, "port")

    @property
    @pulumi.getter(name="tlsServerName")
    def tls_server_name(self) -> Optional[str]:
        return pulumi.get(self, "tls_server_name")

    @property
    @pulumi.getter(name="useHTTPS")
    def use_https(self) -> Optional[bool]:
        return pulumi.get(self, "use_https")

    @property
    @pulumi.getter(name="useNTLM")
    def use_ntlm(self) -> Optional[bool]:
        return pulumi.get(self, "use_ntlm")

    @property
    @pulumi.getter
    def user(self) -> Optional[str]:
        return pulumi.get(self, "user")


@pulumi.output_type
class K0s(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "apiVersion":
            suggest = "api_version"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0s. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0s.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0s.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 api_version: Optional[str] = None,
                 kind: Optional[str] = None,
                 metadata: Optional['outputs.K0sMetadata'] = None,
                 spec: Optional['outputs.K0sSpec'] = None):
        if api_version is not None:
            pulumi.set(__self__, "api_version", api_version)
        if kind is not None:
            pulumi.set(__self__, "kind", kind)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if spec is not None:
            pulumi.set(__self__, "spec", spec)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> Optional[str]:
        return pulumi.get(self, "api_version")

    @property
    @pulumi.getter
    def kind(self) -> Optional[str]:
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter
    def metadata(self) -> Optional['outputs.K0sMetadata']:
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def spec(self) -> Optional['outputs.K0sSpec']:
        return pulumi.get(self, "spec")


@pulumi.output_type
class K0sAPI(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "externalAddress":
            suggest = "external_address"
        elif key == "extraArgs":
            suggest = "extra_args"
        elif key == "k0sApiPort":
            suggest = "k0s_api_port"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sAPI. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sAPI.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sAPI.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 address: Optional[str] = None,
                 external_address: Optional[str] = None,
                 extra_args: Optional[Mapping[str, str]] = None,
                 k0s_api_port: Optional[int] = None,
                 port: Optional[int] = None,
                 sans: Optional[Sequence[str]] = None):
        if address is not None:
            pulumi.set(__self__, "address", address)
        if external_address is not None:
            pulumi.set(__self__, "external_address", external_address)
        if extra_args is not None:
            pulumi.set(__self__, "extra_args", extra_args)
        if k0s_api_port is not None:
            pulumi.set(__self__, "k0s_api_port", k0s_api_port)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if sans is not None:
            pulumi.set(__self__, "sans", sans)

    @property
    @pulumi.getter
    def address(self) -> Optional[str]:
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="externalAddress")
    def external_address(self) -> Optional[str]:
        return pulumi.get(self, "external_address")

    @property
    @pulumi.getter(name="extraArgs")
    def extra_args(self) -> Optional[Mapping[str, str]]:
        return pulumi.get(self, "extra_args")

    @property
    @pulumi.getter(name="k0sApiPort")
    def k0s_api_port(self) -> Optional[int]:
        return pulumi.get(self, "k0s_api_port")

    @property
    @pulumi.getter
    def port(self) -> Optional[int]:
        return pulumi.get(self, "port")

    @property
    @pulumi.getter
    def sans(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "sans")


@pulumi.output_type
class K0sCalico(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "envVars":
            suggest = "env_vars"
        elif key == "flexVolumeDriverPath":
            suggest = "flex_volume_driver_path"
        elif key == "ipAutodetectionMethod":
            suggest = "ip_autodetection_method"
        elif key == "vxlanPort":
            suggest = "vxlan_port"
        elif key == "vxlanVNI":
            suggest = "vxlan_vni"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sCalico. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sCalico.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sCalico.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 env_vars: Optional[Mapping[str, str]] = None,
                 flex_volume_driver_path: Optional[str] = None,
                 ip_autodetection_method: Optional[str] = None,
                 mode: Optional[str] = None,
                 mtu: Optional[int] = None,
                 overlay: Optional[str] = None,
                 vxlan_port: Optional[int] = None,
                 vxlan_vni: Optional[int] = None,
                 wireguard: Optional[bool] = None):
        if env_vars is not None:
            pulumi.set(__self__, "env_vars", env_vars)
        if flex_volume_driver_path is not None:
            pulumi.set(__self__, "flex_volume_driver_path", flex_volume_driver_path)
        if ip_autodetection_method is not None:
            pulumi.set(__self__, "ip_autodetection_method", ip_autodetection_method)
        if mode is not None:
            pulumi.set(__self__, "mode", mode)
        if mtu is not None:
            pulumi.set(__self__, "mtu", mtu)
        if overlay is not None:
            pulumi.set(__self__, "overlay", overlay)
        if vxlan_port is not None:
            pulumi.set(__self__, "vxlan_port", vxlan_port)
        if vxlan_vni is not None:
            pulumi.set(__self__, "vxlan_vni", vxlan_vni)
        if wireguard is not None:
            pulumi.set(__self__, "wireguard", wireguard)

    @property
    @pulumi.getter(name="envVars")
    def env_vars(self) -> Optional[Mapping[str, str]]:
        return pulumi.get(self, "env_vars")

    @property
    @pulumi.getter(name="flexVolumeDriverPath")
    def flex_volume_driver_path(self) -> Optional[str]:
        return pulumi.get(self, "flex_volume_driver_path")

    @property
    @pulumi.getter(name="ipAutodetectionMethod")
    def ip_autodetection_method(self) -> Optional[str]:
        return pulumi.get(self, "ip_autodetection_method")

    @property
    @pulumi.getter
    def mode(self) -> Optional[str]:
        return pulumi.get(self, "mode")

    @property
    @pulumi.getter
    def mtu(self) -> Optional[int]:
        return pulumi.get(self, "mtu")

    @property
    @pulumi.getter
    def overlay(self) -> Optional[str]:
        return pulumi.get(self, "overlay")

    @property
    @pulumi.getter(name="vxlanPort")
    def vxlan_port(self) -> Optional[int]:
        return pulumi.get(self, "vxlan_port")

    @property
    @pulumi.getter(name="vxlanVNI")
    def vxlan_vni(self) -> Optional[int]:
        return pulumi.get(self, "vxlan_vni")

    @property
    @pulumi.getter
    def wireguard(self) -> Optional[bool]:
        return pulumi.get(self, "wireguard")


@pulumi.output_type
class K0sCalicoImage(dict):
    def __init__(__self__, *,
                 cni: Optional['outputs.K0sImage'] = None,
                 flexvolume: Optional['outputs.K0sImage'] = None,
                 kubecontrollers: Optional['outputs.K0sImage'] = None,
                 node: Optional['outputs.K0sImage'] = None):
        if cni is not None:
            pulumi.set(__self__, "cni", cni)
        if flexvolume is not None:
            pulumi.set(__self__, "flexvolume", flexvolume)
        if kubecontrollers is not None:
            pulumi.set(__self__, "kubecontrollers", kubecontrollers)
        if node is not None:
            pulumi.set(__self__, "node", node)

    @property
    @pulumi.getter
    def cni(self) -> Optional['outputs.K0sImage']:
        return pulumi.get(self, "cni")

    @property
    @pulumi.getter
    def flexvolume(self) -> Optional['outputs.K0sImage']:
        return pulumi.get(self, "flexvolume")

    @property
    @pulumi.getter
    def kubecontrollers(self) -> Optional['outputs.K0sImage']:
        return pulumi.get(self, "kubecontrollers")

    @property
    @pulumi.getter
    def node(self) -> Optional['outputs.K0sImage']:
        return pulumi.get(self, "node")


@pulumi.output_type
class K0sControllerManager(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "extraArgs":
            suggest = "extra_args"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sControllerManager. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sControllerManager.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sControllerManager.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 extra_args: Optional[Mapping[str, str]] = None):
        if extra_args is not None:
            pulumi.set(__self__, "extra_args", extra_args)

    @property
    @pulumi.getter(name="extraArgs")
    def extra_args(self) -> Optional[Mapping[str, str]]:
        return pulumi.get(self, "extra_args")


@pulumi.output_type
class K0sDualStack(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "IPv6podCIDR":
            suggest = "i_pv6pod_cidr"
        elif key == "IPv6serviceCIDR":
            suggest = "i_pv6service_cidr"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sDualStack. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sDualStack.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sDualStack.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 i_pv6pod_cidr: Optional[str] = None,
                 i_pv6service_cidr: Optional[str] = None,
                 enabled: Optional[bool] = None):
        if i_pv6pod_cidr is not None:
            pulumi.set(__self__, "i_pv6pod_cidr", i_pv6pod_cidr)
        if i_pv6service_cidr is not None:
            pulumi.set(__self__, "i_pv6service_cidr", i_pv6service_cidr)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)

    @property
    @pulumi.getter(name="IPv6podCIDR")
    def i_pv6pod_cidr(self) -> Optional[str]:
        return pulumi.get(self, "i_pv6pod_cidr")

    @property
    @pulumi.getter(name="IPv6serviceCIDR")
    def i_pv6service_cidr(self) -> Optional[str]:
        return pulumi.get(self, "i_pv6service_cidr")

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        return pulumi.get(self, "enabled")


@pulumi.output_type
class K0sEnvoyProxy(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "apiServerBindPort":
            suggest = "api_server_bind_port"
        elif key == "imagePullPolicy":
            suggest = "image_pull_policy"
        elif key == "konnectivityServerBindPort":
            suggest = "konnectivity_server_bind_port"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sEnvoyProxy. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sEnvoyProxy.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sEnvoyProxy.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 api_server_bind_port: Optional[int] = None,
                 image: Optional[str] = None,
                 image_pull_policy: Optional[str] = None,
                 konnectivity_server_bind_port: Optional[int] = None):
        if api_server_bind_port is not None:
            pulumi.set(__self__, "api_server_bind_port", api_server_bind_port)
        if image is not None:
            pulumi.set(__self__, "image", image)
        if image_pull_policy is not None:
            pulumi.set(__self__, "image_pull_policy", image_pull_policy)
        if konnectivity_server_bind_port is not None:
            pulumi.set(__self__, "konnectivity_server_bind_port", konnectivity_server_bind_port)

    @property
    @pulumi.getter(name="apiServerBindPort")
    def api_server_bind_port(self) -> Optional[int]:
        return pulumi.get(self, "api_server_bind_port")

    @property
    @pulumi.getter
    def image(self) -> Optional[str]:
        return pulumi.get(self, "image")

    @property
    @pulumi.getter(name="imagePullPolicy")
    def image_pull_policy(self) -> Optional[str]:
        return pulumi.get(self, "image_pull_policy")

    @property
    @pulumi.getter(name="konnectivityServerBindPort")
    def konnectivity_server_bind_port(self) -> Optional[int]:
        return pulumi.get(self, "konnectivity_server_bind_port")


@pulumi.output_type
class K0sEtcd(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "externalCluster":
            suggest = "external_cluster"
        elif key == "extraArgs":
            suggest = "extra_args"
        elif key == "peerAddress":
            suggest = "peer_address"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sEtcd. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sEtcd.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sEtcd.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 external_cluster: Optional['outputs.K0sEtcdExternalCluster'] = None,
                 extra_args: Optional[Mapping[str, str]] = None,
                 peer_address: Optional[str] = None):
        if external_cluster is not None:
            pulumi.set(__self__, "external_cluster", external_cluster)
        if extra_args is not None:
            pulumi.set(__self__, "extra_args", extra_args)
        if peer_address is not None:
            pulumi.set(__self__, "peer_address", peer_address)

    @property
    @pulumi.getter(name="externalCluster")
    def external_cluster(self) -> Optional['outputs.K0sEtcdExternalCluster']:
        return pulumi.get(self, "external_cluster")

    @property
    @pulumi.getter(name="extraArgs")
    def extra_args(self) -> Optional[Mapping[str, str]]:
        return pulumi.get(self, "extra_args")

    @property
    @pulumi.getter(name="peerAddress")
    def peer_address(self) -> Optional[str]:
        return pulumi.get(self, "peer_address")


@pulumi.output_type
class K0sEtcdExternalCluster(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "clientCert":
            suggest = "client_cert"
        elif key == "clientKey":
            suggest = "client_key"
        elif key == "etcdPrefix":
            suggest = "etcd_prefix"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sEtcdExternalCluster. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sEtcdExternalCluster.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sEtcdExternalCluster.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 endpoints: Sequence[str],
                 ca: Optional[str] = None,
                 client_cert: Optional[str] = None,
                 client_key: Optional[str] = None,
                 etcd_prefix: Optional[str] = None):
        pulumi.set(__self__, "endpoints", endpoints)
        if ca is not None:
            pulumi.set(__self__, "ca", ca)
        if client_cert is not None:
            pulumi.set(__self__, "client_cert", client_cert)
        if client_key is not None:
            pulumi.set(__self__, "client_key", client_key)
        if etcd_prefix is not None:
            pulumi.set(__self__, "etcd_prefix", etcd_prefix)

    @property
    @pulumi.getter
    def endpoints(self) -> Sequence[str]:
        return pulumi.get(self, "endpoints")

    @property
    @pulumi.getter
    def ca(self) -> Optional[str]:
        return pulumi.get(self, "ca")

    @property
    @pulumi.getter(name="clientCert")
    def client_cert(self) -> Optional[str]:
        return pulumi.get(self, "client_cert")

    @property
    @pulumi.getter(name="clientKey")
    def client_key(self) -> Optional[str]:
        return pulumi.get(self, "client_key")

    @property
    @pulumi.getter(name="etcdPrefix")
    def etcd_prefix(self) -> Optional[str]:
        return pulumi.get(self, "etcd_prefix")


@pulumi.output_type
class K0sFeatureGate(dict):
    def __init__(__self__, *,
                 name: str,
                 components: Optional[Sequence[str]] = None,
                 enabled: Optional[bool] = None):
        pulumi.set(__self__, "name", name)
        if components is not None:
            pulumi.set(__self__, "components", components)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def components(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "components")

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        return pulumi.get(self, "enabled")


@pulumi.output_type
class K0sImage(dict):
    def __init__(__self__, *,
                 image: Optional[str] = None,
                 version: Optional[str] = None):
        if image is not None:
            pulumi.set(__self__, "image", image)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def image(self) -> Optional[str]:
        return pulumi.get(self, "image")

    @property
    @pulumi.getter
    def version(self) -> Optional[str]:
        return pulumi.get(self, "version")


@pulumi.output_type
class K0sImages(dict):
    def __init__(__self__, *,
                 calico: Optional['outputs.K0sCalicoImage'] = None,
                 coredns: Optional['outputs.K0sImage'] = None,
                 default_pull_policy: Optional[str] = None,
                 konnectivity: Optional['outputs.K0sImage'] = None,
                 kubeproxy: Optional['outputs.K0sImage'] = None,
                 kuberouter: Optional['outputs.K0sKubeRouterImage'] = None,
                 metricsserver: Optional['outputs.K0sImage'] = None,
                 pause: Optional['outputs.K0sImage'] = None,
                 repository: Optional[str] = None):
        if calico is not None:
            pulumi.set(__self__, "calico", calico)
        if coredns is not None:
            pulumi.set(__self__, "coredns", coredns)
        if default_pull_policy is not None:
            pulumi.set(__self__, "default_pull_policy", default_pull_policy)
        if konnectivity is not None:
            pulumi.set(__self__, "konnectivity", konnectivity)
        if kubeproxy is not None:
            pulumi.set(__self__, "kubeproxy", kubeproxy)
        if kuberouter is not None:
            pulumi.set(__self__, "kuberouter", kuberouter)
        if metricsserver is not None:
            pulumi.set(__self__, "metricsserver", metricsserver)
        if pause is not None:
            pulumi.set(__self__, "pause", pause)
        if repository is not None:
            pulumi.set(__self__, "repository", repository)

    @property
    @pulumi.getter
    def calico(self) -> Optional['outputs.K0sCalicoImage']:
        return pulumi.get(self, "calico")

    @property
    @pulumi.getter
    def coredns(self) -> Optional['outputs.K0sImage']:
        return pulumi.get(self, "coredns")

    @property
    @pulumi.getter
    def default_pull_policy(self) -> Optional[str]:
        return pulumi.get(self, "default_pull_policy")

    @property
    @pulumi.getter
    def konnectivity(self) -> Optional['outputs.K0sImage']:
        return pulumi.get(self, "konnectivity")

    @property
    @pulumi.getter
    def kubeproxy(self) -> Optional['outputs.K0sImage']:
        return pulumi.get(self, "kubeproxy")

    @property
    @pulumi.getter
    def kuberouter(self) -> Optional['outputs.K0sKubeRouterImage']:
        return pulumi.get(self, "kuberouter")

    @property
    @pulumi.getter
    def metricsserver(self) -> Optional['outputs.K0sImage']:
        return pulumi.get(self, "metricsserver")

    @property
    @pulumi.getter
    def pause(self) -> Optional['outputs.K0sImage']:
        return pulumi.get(self, "pause")

    @property
    @pulumi.getter
    def repository(self) -> Optional[str]:
        return pulumi.get(self, "repository")


@pulumi.output_type
class K0sInstallConfig(dict):
    def __init__(__self__, *,
                 users: Optional['outputs.K0sInstallConfigUser'] = None):
        if users is not None:
            pulumi.set(__self__, "users", users)

    @property
    @pulumi.getter
    def users(self) -> Optional['outputs.K0sInstallConfigUser']:
        return pulumi.get(self, "users")


@pulumi.output_type
class K0sInstallConfigUser(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "etcdUser":
            suggest = "etcd_user"
        elif key == "kineUser":
            suggest = "kine_user"
        elif key == "konnectivityUser":
            suggest = "konnectivity_user"
        elif key == "kubeAPIserverUser":
            suggest = "kube_apiserver_user"
        elif key == "kubeSchedulerUser":
            suggest = "kube_scheduler_user"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sInstallConfigUser. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sInstallConfigUser.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sInstallConfigUser.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 etcd_user: Optional[str] = None,
                 kine_user: Optional[str] = None,
                 konnectivity_user: Optional[str] = None,
                 kube_apiserver_user: Optional[str] = None,
                 kube_scheduler_user: Optional[str] = None):
        if etcd_user is not None:
            pulumi.set(__self__, "etcd_user", etcd_user)
        if kine_user is not None:
            pulumi.set(__self__, "kine_user", kine_user)
        if konnectivity_user is not None:
            pulumi.set(__self__, "konnectivity_user", konnectivity_user)
        if kube_apiserver_user is not None:
            pulumi.set(__self__, "kube_apiserver_user", kube_apiserver_user)
        if kube_scheduler_user is not None:
            pulumi.set(__self__, "kube_scheduler_user", kube_scheduler_user)

    @property
    @pulumi.getter(name="etcdUser")
    def etcd_user(self) -> Optional[str]:
        return pulumi.get(self, "etcd_user")

    @property
    @pulumi.getter(name="kineUser")
    def kine_user(self) -> Optional[str]:
        return pulumi.get(self, "kine_user")

    @property
    @pulumi.getter(name="konnectivityUser")
    def konnectivity_user(self) -> Optional[str]:
        return pulumi.get(self, "konnectivity_user")

    @property
    @pulumi.getter(name="kubeAPIserverUser")
    def kube_apiserver_user(self) -> Optional[str]:
        return pulumi.get(self, "kube_apiserver_user")

    @property
    @pulumi.getter(name="kubeSchedulerUser")
    def kube_scheduler_user(self) -> Optional[str]:
        return pulumi.get(self, "kube_scheduler_user")


@pulumi.output_type
class K0sKine(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dataSource":
            suggest = "data_source"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sKine. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sKine.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sKine.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 data_source: str):
        pulumi.set(__self__, "data_source", data_source)

    @property
    @pulumi.getter(name="dataSource")
    def data_source(self) -> str:
        return pulumi.get(self, "data_source")


@pulumi.output_type
class K0sKonnectivity(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "adminPort":
            suggest = "admin_port"
        elif key == "agentPort":
            suggest = "agent_port"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sKonnectivity. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sKonnectivity.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sKonnectivity.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 admin_port: Optional[int] = None,
                 agent_port: Optional[int] = None):
        if admin_port is not None:
            pulumi.set(__self__, "admin_port", admin_port)
        if agent_port is not None:
            pulumi.set(__self__, "agent_port", agent_port)

    @property
    @pulumi.getter(name="adminPort")
    def admin_port(self) -> Optional[int]:
        return pulumi.get(self, "admin_port")

    @property
    @pulumi.getter(name="agentPort")
    def agent_port(self) -> Optional[int]:
        return pulumi.get(self, "agent_port")


@pulumi.output_type
class K0sKubeProxy(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "nodePortAddresses":
            suggest = "node_port_addresses"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sKubeProxy. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sKubeProxy.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sKubeProxy.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 disabled: Optional[bool] = None,
                 iptables: Optional['outputs.K0sKubeProxyIPTables'] = None,
                 ipvs: Optional['outputs.K0sKubeProxyIPVS'] = None,
                 mode: Optional[str] = None,
                 node_port_addresses: Optional[str] = None):
        if disabled is not None:
            pulumi.set(__self__, "disabled", disabled)
        if iptables is not None:
            pulumi.set(__self__, "iptables", iptables)
        if ipvs is not None:
            pulumi.set(__self__, "ipvs", ipvs)
        if mode is not None:
            pulumi.set(__self__, "mode", mode)
        if node_port_addresses is not None:
            pulumi.set(__self__, "node_port_addresses", node_port_addresses)

    @property
    @pulumi.getter
    def disabled(self) -> Optional[bool]:
        return pulumi.get(self, "disabled")

    @property
    @pulumi.getter
    def iptables(self) -> Optional['outputs.K0sKubeProxyIPTables']:
        return pulumi.get(self, "iptables")

    @property
    @pulumi.getter
    def ipvs(self) -> Optional['outputs.K0sKubeProxyIPVS']:
        return pulumi.get(self, "ipvs")

    @property
    @pulumi.getter
    def mode(self) -> Optional[str]:
        return pulumi.get(self, "mode")

    @property
    @pulumi.getter(name="nodePortAddresses")
    def node_port_addresses(self) -> Optional[str]:
        return pulumi.get(self, "node_port_addresses")


@pulumi.output_type
class K0sKubeProxyIPTables(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "masqueradeAll":
            suggest = "masquerade_all"
        elif key == "masqueradeBit":
            suggest = "masquerade_bit"
        elif key == "minSyncPeriod":
            suggest = "min_sync_period"
        elif key == "syncPeriod":
            suggest = "sync_period"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sKubeProxyIPTables. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sKubeProxyIPTables.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sKubeProxyIPTables.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 masquerade_all: Optional[bool] = None,
                 masquerade_bit: Optional[int] = None,
                 min_sync_period: Optional[str] = None,
                 sync_period: Optional[str] = None):
        if masquerade_all is not None:
            pulumi.set(__self__, "masquerade_all", masquerade_all)
        if masquerade_bit is not None:
            pulumi.set(__self__, "masquerade_bit", masquerade_bit)
        if min_sync_period is not None:
            pulumi.set(__self__, "min_sync_period", min_sync_period)
        if sync_period is not None:
            pulumi.set(__self__, "sync_period", sync_period)

    @property
    @pulumi.getter(name="masqueradeAll")
    def masquerade_all(self) -> Optional[bool]:
        return pulumi.get(self, "masquerade_all")

    @property
    @pulumi.getter(name="masqueradeBit")
    def masquerade_bit(self) -> Optional[int]:
        return pulumi.get(self, "masquerade_bit")

    @property
    @pulumi.getter(name="minSyncPeriod")
    def min_sync_period(self) -> Optional[str]:
        return pulumi.get(self, "min_sync_period")

    @property
    @pulumi.getter(name="syncPeriod")
    def sync_period(self) -> Optional[str]:
        return pulumi.get(self, "sync_period")


@pulumi.output_type
class K0sKubeProxyIPVS(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "excludeCIDRs":
            suggest = "exclude_cidrs"
        elif key == "minSyncPeriod":
            suggest = "min_sync_period"
        elif key == "strictARP":
            suggest = "strict_arp"
        elif key == "syncPeriod":
            suggest = "sync_period"
        elif key == "tcpFinTimeout":
            suggest = "tcp_fin_timeout"
        elif key == "tcpTimeout":
            suggest = "tcp_timeout"
        elif key == "udpTimeout":
            suggest = "udp_timeout"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sKubeProxyIPVS. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sKubeProxyIPVS.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sKubeProxyIPVS.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 exclude_cidrs: Optional[str] = None,
                 min_sync_period: Optional[str] = None,
                 scheduler: Optional[str] = None,
                 strict_arp: Optional[bool] = None,
                 sync_period: Optional[str] = None,
                 tcp_fin_timeout: Optional[str] = None,
                 tcp_timeout: Optional[str] = None,
                 udp_timeout: Optional[str] = None):
        if exclude_cidrs is not None:
            pulumi.set(__self__, "exclude_cidrs", exclude_cidrs)
        if min_sync_period is not None:
            pulumi.set(__self__, "min_sync_period", min_sync_period)
        if scheduler is not None:
            pulumi.set(__self__, "scheduler", scheduler)
        if strict_arp is not None:
            pulumi.set(__self__, "strict_arp", strict_arp)
        if sync_period is not None:
            pulumi.set(__self__, "sync_period", sync_period)
        if tcp_fin_timeout is not None:
            pulumi.set(__self__, "tcp_fin_timeout", tcp_fin_timeout)
        if tcp_timeout is not None:
            pulumi.set(__self__, "tcp_timeout", tcp_timeout)
        if udp_timeout is not None:
            pulumi.set(__self__, "udp_timeout", udp_timeout)

    @property
    @pulumi.getter(name="excludeCIDRs")
    def exclude_cidrs(self) -> Optional[str]:
        return pulumi.get(self, "exclude_cidrs")

    @property
    @pulumi.getter(name="minSyncPeriod")
    def min_sync_period(self) -> Optional[str]:
        return pulumi.get(self, "min_sync_period")

    @property
    @pulumi.getter
    def scheduler(self) -> Optional[str]:
        return pulumi.get(self, "scheduler")

    @property
    @pulumi.getter(name="strictARP")
    def strict_arp(self) -> Optional[bool]:
        return pulumi.get(self, "strict_arp")

    @property
    @pulumi.getter(name="syncPeriod")
    def sync_period(self) -> Optional[str]:
        return pulumi.get(self, "sync_period")

    @property
    @pulumi.getter(name="tcpFinTimeout")
    def tcp_fin_timeout(self) -> Optional[str]:
        return pulumi.get(self, "tcp_fin_timeout")

    @property
    @pulumi.getter(name="tcpTimeout")
    def tcp_timeout(self) -> Optional[str]:
        return pulumi.get(self, "tcp_timeout")

    @property
    @pulumi.getter(name="udpTimeout")
    def udp_timeout(self) -> Optional[str]:
        return pulumi.get(self, "udp_timeout")


@pulumi.output_type
class K0sKubeRouter(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "autoMTU":
            suggest = "auto_mtu"
        elif key == "extraArgs":
            suggest = "extra_args"
        elif key == "ipMasq":
            suggest = "ip_masq"
        elif key == "metricsPort":
            suggest = "metrics_port"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sKubeRouter. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sKubeRouter.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sKubeRouter.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 auto_mtu: Optional[bool] = None,
                 extra_args: Optional[Mapping[str, str]] = None,
                 hairpin: Optional[str] = None,
                 ip_masq: Optional[bool] = None,
                 metrics_port: Optional[int] = None,
                 mtu: Optional[int] = None):
        if auto_mtu is not None:
            pulumi.set(__self__, "auto_mtu", auto_mtu)
        if extra_args is not None:
            pulumi.set(__self__, "extra_args", extra_args)
        if hairpin is not None:
            pulumi.set(__self__, "hairpin", hairpin)
        if ip_masq is not None:
            pulumi.set(__self__, "ip_masq", ip_masq)
        if metrics_port is not None:
            pulumi.set(__self__, "metrics_port", metrics_port)
        if mtu is not None:
            pulumi.set(__self__, "mtu", mtu)

    @property
    @pulumi.getter(name="autoMTU")
    def auto_mtu(self) -> Optional[bool]:
        return pulumi.get(self, "auto_mtu")

    @property
    @pulumi.getter(name="extraArgs")
    def extra_args(self) -> Optional[Mapping[str, str]]:
        return pulumi.get(self, "extra_args")

    @property
    @pulumi.getter
    def hairpin(self) -> Optional[str]:
        return pulumi.get(self, "hairpin")

    @property
    @pulumi.getter(name="ipMasq")
    def ip_masq(self) -> Optional[bool]:
        return pulumi.get(self, "ip_masq")

    @property
    @pulumi.getter(name="metricsPort")
    def metrics_port(self) -> Optional[int]:
        return pulumi.get(self, "metrics_port")

    @property
    @pulumi.getter
    def mtu(self) -> Optional[int]:
        return pulumi.get(self, "mtu")


@pulumi.output_type
class K0sKubeRouterImage(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "cniInstaller":
            suggest = "cni_installer"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sKubeRouterImage. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sKubeRouterImage.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sKubeRouterImage.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 cni: Optional['outputs.K0sImage'] = None,
                 cni_installer: Optional['outputs.K0sImage'] = None):
        if cni is not None:
            pulumi.set(__self__, "cni", cni)
        if cni_installer is not None:
            pulumi.set(__self__, "cni_installer", cni_installer)

    @property
    @pulumi.getter
    def cni(self) -> Optional['outputs.K0sImage']:
        return pulumi.get(self, "cni")

    @property
    @pulumi.getter(name="cniInstaller")
    def cni_installer(self) -> Optional['outputs.K0sImage']:
        return pulumi.get(self, "cni_installer")


@pulumi.output_type
class K0sMetadata(dict):
    def __init__(__self__, *,
                 name: str):
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


@pulumi.output_type
class K0sNetwork(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "clusterDomain":
            suggest = "cluster_domain"
        elif key == "dualStack":
            suggest = "dual_stack"
        elif key == "kubeProxy":
            suggest = "kube_proxy"
        elif key == "nodeLocalLoadBalancing":
            suggest = "node_local_load_balancing"
        elif key == "podCIDR":
            suggest = "pod_cidr"
        elif key == "serviceCIDR":
            suggest = "service_cidr"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sNetwork. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sNetwork.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sNetwork.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 calico: Optional['outputs.K0sCalico'] = None,
                 cluster_domain: Optional[str] = None,
                 dual_stack: Optional['outputs.K0sDualStack'] = None,
                 kube_proxy: Optional['outputs.K0sKubeProxy'] = None,
                 kuberouter: Optional['outputs.K0sKubeRouter'] = None,
                 node_local_load_balancing: Optional['outputs.K0sNodeLocalLoadBalancing'] = None,
                 pod_cidr: Optional[str] = None,
                 provider: Optional[str] = None,
                 service_cidr: Optional[str] = None):
        if calico is not None:
            pulumi.set(__self__, "calico", calico)
        if cluster_domain is not None:
            pulumi.set(__self__, "cluster_domain", cluster_domain)
        if dual_stack is not None:
            pulumi.set(__self__, "dual_stack", dual_stack)
        if kube_proxy is not None:
            pulumi.set(__self__, "kube_proxy", kube_proxy)
        if kuberouter is not None:
            pulumi.set(__self__, "kuberouter", kuberouter)
        if node_local_load_balancing is not None:
            pulumi.set(__self__, "node_local_load_balancing", node_local_load_balancing)
        if pod_cidr is not None:
            pulumi.set(__self__, "pod_cidr", pod_cidr)
        if provider is not None:
            pulumi.set(__self__, "provider", provider)
        if service_cidr is not None:
            pulumi.set(__self__, "service_cidr", service_cidr)

    @property
    @pulumi.getter
    def calico(self) -> Optional['outputs.K0sCalico']:
        return pulumi.get(self, "calico")

    @property
    @pulumi.getter(name="clusterDomain")
    def cluster_domain(self) -> Optional[str]:
        return pulumi.get(self, "cluster_domain")

    @property
    @pulumi.getter(name="dualStack")
    def dual_stack(self) -> Optional['outputs.K0sDualStack']:
        return pulumi.get(self, "dual_stack")

    @property
    @pulumi.getter(name="kubeProxy")
    def kube_proxy(self) -> Optional['outputs.K0sKubeProxy']:
        return pulumi.get(self, "kube_proxy")

    @property
    @pulumi.getter
    def kuberouter(self) -> Optional['outputs.K0sKubeRouter']:
        return pulumi.get(self, "kuberouter")

    @property
    @pulumi.getter(name="nodeLocalLoadBalancing")
    def node_local_load_balancing(self) -> Optional['outputs.K0sNodeLocalLoadBalancing']:
        return pulumi.get(self, "node_local_load_balancing")

    @property
    @pulumi.getter(name="podCIDR")
    def pod_cidr(self) -> Optional[str]:
        return pulumi.get(self, "pod_cidr")

    @property
    @pulumi.getter
    def provider(self) -> Optional[str]:
        return pulumi.get(self, "provider")

    @property
    @pulumi.getter(name="serviceCIDR")
    def service_cidr(self) -> Optional[str]:
        return pulumi.get(self, "service_cidr")


@pulumi.output_type
class K0sNodeLocalLoadBalancing(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "envoyProxy":
            suggest = "envoy_proxy"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sNodeLocalLoadBalancing. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sNodeLocalLoadBalancing.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sNodeLocalLoadBalancing.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 enabled: Optional[bool] = None,
                 envoy_proxy: Optional['outputs.K0sEnvoyProxy'] = None,
                 type: Optional[str] = None):
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if envoy_proxy is not None:
            pulumi.set(__self__, "envoy_proxy", envoy_proxy)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="envoyProxy")
    def envoy_proxy(self) -> Optional['outputs.K0sEnvoyProxy']:
        return pulumi.get(self, "envoy_proxy")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        return pulumi.get(self, "type")


@pulumi.output_type
class K0sPodSecurityPolicy(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "defaultPolicy":
            suggest = "default_policy"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sPodSecurityPolicy. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sPodSecurityPolicy.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sPodSecurityPolicy.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 default_policy: Optional[str] = None):
        if default_policy is not None:
            pulumi.set(__self__, "default_policy", default_policy)

    @property
    @pulumi.getter(name="defaultPolicy")
    def default_policy(self) -> Optional[str]:
        return pulumi.get(self, "default_policy")


@pulumi.output_type
class K0sScheduler(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "extraArgs":
            suggest = "extra_args"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sScheduler. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sScheduler.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sScheduler.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 extra_args: Optional[Mapping[str, str]] = None):
        if extra_args is not None:
            pulumi.set(__self__, "extra_args", extra_args)

    @property
    @pulumi.getter(name="extraArgs")
    def extra_args(self) -> Optional[Mapping[str, str]]:
        return pulumi.get(self, "extra_args")


@pulumi.output_type
class K0sSpec(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "controllerManager":
            suggest = "controller_manager"
        elif key == "featureGates":
            suggest = "feature_gates"
        elif key == "installConfig":
            suggest = "install_config"
        elif key == "podSecurityPolicy":
            suggest = "pod_security_policy"
        elif key == "workerProfiles":
            suggest = "worker_profiles"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in K0sSpec. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        K0sSpec.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        K0sSpec.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 api: Optional['outputs.K0sAPI'] = None,
                 controller_manager: Optional['outputs.K0sControllerManager'] = None,
                 feature_gates: Optional[Sequence['outputs.K0sFeatureGate']] = None,
                 images: Optional['outputs.K0sImages'] = None,
                 install_config: Optional['outputs.K0sInstallConfig'] = None,
                 konnectivity: Optional['outputs.K0sKonnectivity'] = None,
                 network: Optional['outputs.K0sNetwork'] = None,
                 pod_security_policy: Optional['outputs.K0sPodSecurityPolicy'] = None,
                 scheduler: Optional['outputs.K0sScheduler'] = None,
                 storage: Optional['outputs.K0sStorage'] = None,
                 telemetry: Optional['outputs.K0sTelemetry'] = None,
                 worker_profiles: Optional[Sequence['outputs.K0sWorkerProfile']] = None):
        if api is not None:
            pulumi.set(__self__, "api", api)
        if controller_manager is not None:
            pulumi.set(__self__, "controller_manager", controller_manager)
        if feature_gates is not None:
            pulumi.set(__self__, "feature_gates", feature_gates)
        if images is not None:
            pulumi.set(__self__, "images", images)
        if install_config is not None:
            pulumi.set(__self__, "install_config", install_config)
        if konnectivity is not None:
            pulumi.set(__self__, "konnectivity", konnectivity)
        if network is not None:
            pulumi.set(__self__, "network", network)
        if pod_security_policy is not None:
            pulumi.set(__self__, "pod_security_policy", pod_security_policy)
        if scheduler is not None:
            pulumi.set(__self__, "scheduler", scheduler)
        if storage is not None:
            pulumi.set(__self__, "storage", storage)
        if telemetry is not None:
            pulumi.set(__self__, "telemetry", telemetry)
        if worker_profiles is not None:
            pulumi.set(__self__, "worker_profiles", worker_profiles)

    @property
    @pulumi.getter
    def api(self) -> Optional['outputs.K0sAPI']:
        return pulumi.get(self, "api")

    @property
    @pulumi.getter(name="controllerManager")
    def controller_manager(self) -> Optional['outputs.K0sControllerManager']:
        return pulumi.get(self, "controller_manager")

    @property
    @pulumi.getter(name="featureGates")
    def feature_gates(self) -> Optional[Sequence['outputs.K0sFeatureGate']]:
        return pulumi.get(self, "feature_gates")

    @property
    @pulumi.getter
    def images(self) -> Optional['outputs.K0sImages']:
        return pulumi.get(self, "images")

    @property
    @pulumi.getter(name="installConfig")
    def install_config(self) -> Optional['outputs.K0sInstallConfig']:
        return pulumi.get(self, "install_config")

    @property
    @pulumi.getter
    def konnectivity(self) -> Optional['outputs.K0sKonnectivity']:
        return pulumi.get(self, "konnectivity")

    @property
    @pulumi.getter
    def network(self) -> Optional['outputs.K0sNetwork']:
        return pulumi.get(self, "network")

    @property
    @pulumi.getter(name="podSecurityPolicy")
    def pod_security_policy(self) -> Optional['outputs.K0sPodSecurityPolicy']:
        return pulumi.get(self, "pod_security_policy")

    @property
    @pulumi.getter
    def scheduler(self) -> Optional['outputs.K0sScheduler']:
        return pulumi.get(self, "scheduler")

    @property
    @pulumi.getter
    def storage(self) -> Optional['outputs.K0sStorage']:
        return pulumi.get(self, "storage")

    @property
    @pulumi.getter
    def telemetry(self) -> Optional['outputs.K0sTelemetry']:
        return pulumi.get(self, "telemetry")

    @property
    @pulumi.getter(name="workerProfiles")
    def worker_profiles(self) -> Optional[Sequence['outputs.K0sWorkerProfile']]:
        return pulumi.get(self, "worker_profiles")


@pulumi.output_type
class K0sStorage(dict):
    def __init__(__self__, *,
                 etcd: Optional['outputs.K0sEtcd'] = None,
                 kine: Optional['outputs.K0sKine'] = None,
                 type: Optional[str] = None):
        if etcd is not None:
            pulumi.set(__self__, "etcd", etcd)
        if kine is not None:
            pulumi.set(__self__, "kine", kine)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def etcd(self) -> Optional['outputs.K0sEtcd']:
        return pulumi.get(self, "etcd")

    @property
    @pulumi.getter
    def kine(self) -> Optional['outputs.K0sKine']:
        return pulumi.get(self, "kine")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        return pulumi.get(self, "type")


@pulumi.output_type
class K0sTelemetry(dict):
    def __init__(__self__, *,
                 enabled: Optional[bool] = None):
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[bool]:
        return pulumi.get(self, "enabled")


@pulumi.output_type
class K0sWorkerProfile(dict):
    def __init__(__self__, *,
                 name: str,
                 values: Mapping[str, Any]):
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def values(self) -> Mapping[str, Any]:
        return pulumi.get(self, "values")


